找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1189|回复: 0

[分享] Draw Order Problem with Dynamic Block

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-11 22:10:58 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
        [CommandMethod("DOinBlock")]
        public static void RunMyCommand()
        {
            Document dwg = Application.DocumentManager.MdiActiveDocument;
            Editor ed = dwg.Editor;

            //Ask user to select a block. In real world, I use code
            //to select all targeting blocks by its name, so that
            //user does not have to select block manually
            PromptEntityOptions opt = new PromptEntityOptions(
                "nSelect a block:");
            opt.SetRejectMessage("\nInvalid: not a block.");
            opt.AddAllowedClass(typeof(BlockReference), true);
            PromptEntityResult res = ed.GetEntity(opt);
            if (res.Status == PromptStatus.OK)
            {
                SetDrawOrderInBlock(dwg, res.ObjectId);
                ed.Regen();
            }
            else
            {
                ed.WriteMessage("\n*Cancel*");
            }
            Autodesk.AutoCAD.Internal.Utils.PostCommandPrompt();
        }

        private static void SetDrawOrderInBlock(Document dwg, ObjectId blkId)
        {
            using (Transaction tran = dwg.TransactionManager.StartTransaction())
            {
                BlockReference bref = (BlockReference)tran.GetObject(blkId, OpenMode.ForRead);
                BlockTableRecord bdef = (BlockTableRecord)tran.GetObject(bref.BlockTableRecord, OpenMode.ForWrite);
                DrawOrderTable doTbl = (DrawOrderTable)tran.GetObject(bdef.DrawOrderTableId, OpenMode.ForWrite);
                ObjectIdCollection col = new ObjectIdCollection();
                foreach (ObjectId id in bdef)
                {
                    if (id.ObjectClass.DxfName.ToUpper() == "HATCH")
                    {
                        col.Add(id);
                    }
                }
                if (col.Count > 0)
                {
                    doTbl.MoveToBottom(col);
                }
                tran.Commit();
            }
        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-22 19:14 , Processed in 0.222566 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表